local highlight_selected_track = true

local items = {}
local last_item = 0
function item(item_def)
  local prop_name = string.lower(item_def.name):gsub(" ", "_")
  last_item = last_item + 1
  items[prop_name] = last_item
  return item_def
end

function remote_init(manufacturer, model)
  remote.define_items {
    item{name="Remote Base Channel", input="value", output="value", min=1, max=128},
    -- Mixer
    item{name="Channel 1 Channel Name", output="text"},
    item{name="Channel 2 Channel Name", output="text"},
    item{name="Channel 3 Channel Name", output="text"},
    item{name="Channel 4 Channel Name", output="text"},
    item{name="Channel 5 Channel Name", output="text"},
    item{name="Channel 6 Channel Name", output="text"},
    item{name="Channel 7 Channel Name", output="text"},
    item{name="Channel 8 Channel Name", output="text"},
    item{name="Channel 9 Channel Name", output="text"},
    item{name="Channel 10 Channel Name", output="text"},
    item{name="Channel 11 Channel Name", output="text"},
    item{name="Channel 12 Channel Name", output="text"},
    item{name="Channel 13 Channel Name", output="text"},
    item{name="Channel 14 Channel Name", output="text"},
    item{name="Channel 15 Channel Name", output="text"},
    item{name="Channel 16 Channel Name", output="text"},
    item{name="Channel 17 Channel Name", output="text"},
    item{name="Channel 18 Channel Name", output="text"},
    item{name="Channel 19 Channel Name", output="text"},
    item{name="Channel 20 Channel Name", output="text"},
    item{name="Channel 21 Channel Name", output="text"},
    item{name="Channel 22 Channel Name", output="text"},
    item{name="Channel 23 Channel Name", output="text"},
    item{name="Channel 24 Channel Name", output="text"},
    item{name="Channel 25 Channel Name", output="text"},
    item{name="Channel 26 Channel Name", output="text"},
    item{name="Channel 27 Channel Name", output="text"},
    item{name="Channel 28 Channel Name", output="text"},
    item{name="Channel 29 Channel Name", output="text"},
    item{name="Channel 30 Channel Name", output="text"},
    item{name="Channel 31 Channel Name", output="text"},
    item{name="Channel 32 Channel Name", output="text"},
    item{name="Channel 33 Channel Name", output="text"},
    item{name="Channel 34 Channel Name", output="text"},
    item{name="Channel 35 Channel Name", output="text"},
    item{name="Channel 36 Channel Name", output="text"},
    item{name="Channel 37 Channel Name", output="text"},
    item{name="Channel 38 Channel Name", output="text"},
    item{name="Channel 39 Channel Name", output="text"},
    item{name="Channel 40 Channel Name", output="text"},
    item{name="Channel 41 Channel Name", output="text"},
    item{name="Channel 42 Channel Name", output="text"},
    item{name="Channel 43 Channel Name", output="text"},
    item{name="Channel 44 Channel Name", output="text"},
    item{name="Channel 45 Channel Name", output="text"},
    item{name="Channel 46 Channel Name", output="text"},
    item{name="Channel 47 Channel Name", output="text"},
    item{name="Channel 48 Channel Name", output="text"},
    item{name="Channel 49 Channel Name", output="text"},
    item{name="Channel 50 Channel Name", output="text"},
    item{name="Channel 51 Channel Name", output="text"},
    item{name="Channel 52 Channel Name", output="text"},
    item{name="Channel 53 Channel Name", output="text"},
    item{name="Channel 54 Channel Name", output="text"},
    item{name="Channel 55 Channel Name", output="text"},
    item{name="Channel 56 Channel Name", output="text"},
    item{name="Channel 57 Channel Name", output="text"},
    item{name="Channel 58 Channel Name", output="text"},
    item{name="Channel 59 Channel Name", output="text"},
    item{name="Channel 60 Channel Name", output="text"},
    item{name="Channel 61 Channel Name", output="text"},
    item{name="Channel 62 Channel Name", output="text"},
    item{name="Channel 63 Channel Name", output="text"},
    item{name="Channel 64 Channel Name", output="text"},
    -- Mixer Levels
    item{name="Channel 1 Level", input="value", output="value", min=0, max=1000},
    item{name="Channel 2 Level", input="value", output="value", min=0, max=1000},
    item{name="Channel 3 Level", input="value", output="value", min=0, max=1000},
    item{name="Channel 4 Level", input="value", output="value", min=0, max=1000},
    item{name="Channel 5 Level", input="value", output="value", min=0, max=1000},
    item{name="Channel 6 Level", input="value", output="value", min=0, max=1000},
    item{name="Channel 7 Level", input="value", output="value", min=0, max=1000},
    item{name="Channel 8 Level", input="value", output="value", min=0, max=1000},
    -- Mixer Pans
    item{name="Channel 1 Pan", input="value", output="value", min=-100, max=100},
    item{name="Channel 2 Pan", input="value", output="value", min=-100, max=100},
    item{name="Channel 3 Pan", input="value", output="value", min=-100, max=100},
    item{name="Channel 4 Pan", input="value", output="value", min=-100, max=100},
    item{name="Channel 5 Pan", input="value", output="value", min=-100, max=100},
    item{name="Channel 6 Pan", input="value", output="value", min=-100, max=100},
    item{name="Channel 7 Pan", input="value", output="value", min=-100, max=100},
    item{name="Channel 8 Pan", input="value", output="value", min=-100, max=100},
    -- Mixer Mutes
    item{name="Channel 1 Mute", input="value", output="value", min=0, max=1},
    item{name="Channel 2 Mute", input="value", output="value", min=0, max=1},
    item{name="Channel 3 Mute", input="value", output="value", min=0, max=1},
    item{name="Channel 4 Mute", input="value", output="value", min=0, max=1},
    item{name="Channel 5 Mute", input="value", output="value", min=0, max=1},
    item{name="Channel 6 Mute", input="value", output="value", min=0, max=1},
    item{name="Channel 7 Mute", input="value", output="value", min=0, max=1},
    item{name="Channel 8 Mute", input="value", output="value", min=0, max=1},
    -- Mixer Solos
    item{name="Channel 1 Solo", input="value", output="value", min=0, max=1},
    item{name="Channel 2 Solo", input="value", output="value", min=0, max=1},
    item{name="Channel 3 Solo", input="value", output="value", min=0, max=1},
    item{name="Channel 4 Solo", input="value", output="value", min=0, max=1},
    item{name="Channel 5 Solo", input="value", output="value", min=0, max=1},
    item{name="Channel 6 Solo", input="value", output="value", min=0, max=1},
    item{name="Channel 7 Solo", input="value", output="value", min=0, max=1},
    item{name="Channel 8 Solo", input="value", output="value", min=0, max=1},
    -- Mixer Meters L
    item{name="Channel 1 VU Meter L", output="value", min=0, max=32},
    item{name="Channel 2 VU Meter L", output="value", min=0, max=32},
    item{name="Channel 3 VU Meter L", output="value", min=0, max=32},
    item{name="Channel 4 VU Meter L", output="value", min=0, max=32},
    item{name="Channel 5 VU Meter L", output="value", min=0, max=32},
    item{name="Channel 6 VU Meter L", output="value", min=0, max=32},
    item{name="Channel 7 VU Meter L", output="value", min=0, max=32},
    item{name="Channel 8 VU Meter L", output="value", min=0, max=32},
    -- Mixer Meters R
    item{name="Channel 1 VU Meter R", output="value", min=0, max=32},
    item{name="Channel 2 VU Meter R", output="value", min=0, max=32},
    item{name="Channel 3 VU Meter R", output="value", min=0, max=32},
    item{name="Channel 4 VU Meter R", output="value", min=0, max=32},
    item{name="Channel 5 VU Meter R", output="value", min=0, max=32},
    item{name="Channel 6 VU Meter R", output="value", min=0, max=32},
    item{name="Channel 7 VU Meter R", output="value", min=0, max=32},
    item{name="Channel 8 VU Meter R", output="value", min=0, max=32},
    -- Mixer pages
    item{name="Target Track Name", output="text"},
    item{name="Next 8 Remote Base Channel", input="value", min=0, max=1},
    item{name="Previous 8 Remote Base Channel", input="value", min=0, max=1},
    -- 
    item{name="Jog Wheel", input="delta"},
  }
  
  remote.define_auto_inputs {
		{pattern="bf 31 01", name="Next 8 Remote Base Channel", value="1"},
		{pattern="bf 31 7f", name="Previous 8 Remote Base Channel", value="1"},
  }

  remote.define_auto_outputs {
  }
end

-- Controller state
local start_time=remote.get_time_ms()
local current_channel_name=""
local remote_base_channel=1
local max_remote_base_channel=1
local channel_name_to_index={}
local channel_names={}
local mixer_vu_meters={0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0}
local mixer_levels={0,0,0,0,0,0,0,0}
local mixer_pans={0,0,0,0,0,0,0,0}
local mixer_mutes={0,0,0,0,0,0,0,0}
local mixer_solos={0,0,0,0,0,0,0,0}
local vu_meters_changed = false
local mixer_page_buttons_changed = false
local pending_events={}
local pending_inputs={}

function remote_set_state(changed_items)
	for i,item_index in ipairs(changed_items) do
    if item_index == items.remote_base_channel then
      remote_base_channel = remote.get_item_value(items.remote_base_channel)
      max_remote_base_channel=math.max(remote_base_channel, max_remote_base_channel)
      mixer_page_buttons_changed=true
    elseif item_index >= items.channel_1_channel_name and item_index <= items.channel_64_channel_name then
      local channel_index = item_index - items.channel_1_channel_name + 1 -- from remote base
      local channel_hex = numbers_to_hex{channel_index-1}
      local channel_name = trim(remote.get_item_text_value(item_index))
      local global_channel_index = remote_base_channel + channel_index - 1 -- in the whole mixer
      if channel_name ~= "" then
        local prev_max_remote_base = max_remote_base_channel
        max_remote_base_channel = math.max(max_remote_base_channel, math.floor((global_channel_index-1)/8)*8+1)
        mixer_page_buttons_changed = mixer_page_buttons_changed or max_remote_base_channel ~= prev_max_remote_base
        channel_name_to_index[channel_name] = global_channel_index
        channel_names[global_channel_index] = channel_name
        if item_index <= items.channel_8_channel_name then
          local channel_selected = highlight_selected_track and is_channel_selected(channel_name) and "01" or "00"
          table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 40 01" .. channel_hex .. "f7"))
          table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 42" .. channel_selected .. channel_hex .. "f7"))
          table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 48 03" .. channel_hex .. string_to_hex(channel_name) .. "f7"))
        end
      else
        local previous_name = channel_names[global_channel_index]
        local previous_name_index = channel_name_to_index[previous_name]
        channel_names[global_channel_index] = nil
        if previous_name_index ~= nil then table.remove(channel_name_to_index, previous_name_index) end
        if item_index <= items.channel_8_channel_name then
          table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 40 00" .. channel_hex .. "f7"))
          table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 42 00" .. channel_hex .. "f7"))
        end
      end
    elseif item_index >= items.channel_1_level and item_index <= items.channel_8_level then
      local channel_index = item_index - items.channel_1_level + 1
      local channel_hex = numbers_to_hex{channel_index-1}
      local level = remote.get_item_value(item_index)
      mixer_levels[channel_index] = level
      local midi_level = math.min(level * 127 / 1000, 127)
      table.insert(pending_events, remote.make_midi(numbers_to_hex{0xbf, 0x50+channel_index-1, midi_level}))
      table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 46 00" .. channel_hex .. string_to_hex(remote.get_item_text_value(item_index)) .."f7"))
    elseif item_index >= items.channel_1_pan and item_index <= items.channel_8_pan then
      local channel_index = item_index - items.channel_1_pan + 1
      local channel_hex = numbers_to_hex{channel_index-1}
      local pan = remote.get_item_value(item_index)
      local midi_pan = math.min(127, (pan+100) * 127 / 200)
      local hex_pan = pan == 0 and string_to_hex("C") or string_to_hex(remote.get_item_text_value(item_index))
      mixer_pans[channel_index] = pan
      table.insert(pending_events, remote.make_midi(numbers_to_hex{0xbf, 0x58+channel_index-1, midi_pan}))
      table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 47 00" .. channel_hex .. hex_pan .."f7"))
    elseif item_index >= items.channel_1_mute and item_index <= items.channel_8_mute then
      local channel_index = item_index - items.channel_1_mute + 1
      local channel_hex = numbers_to_hex{channel_index-1}
      local channel_mute = remote.get_item_value(item_index)
      local channel_mute_hex = numbers_to_hex{channel_mute}
      mixer_mutes[channel_index] = channel_mute
      table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 43" .. channel_mute_hex .. channel_hex .. "f7"))
    elseif item_index >= items.channel_1_solo and item_index <= items.channel_8_solo then
      local channel_index = item_index - items.channel_1_solo + 1
      local channel_hex = numbers_to_hex{channel_index-1}
      local channel_solo = remote.get_item_value(item_index)
      local channel_solo_hex = numbers_to_hex{channel_solo}
      mixer_solos[channel_index] = channel_solo
      table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 44" .. channel_solo_hex .. channel_hex .. "f7"))
    elseif item_index >= items.channel_1_vu_meter_l and item_index <= items.channel_8_vu_meter_l then
      mixer_vu_meters[(item_index - items.channel_1_vu_meter_l + 1)*2] = math.min(remote.get_item_value(item_index) * 127 / (32 - 1), 127)
      vu_meters_changed = true
    elseif item_index >= items.channel_1_vu_meter_r and item_index <= items.channel_8_vu_meter_r then
      mixer_vu_meters[(item_index - items.channel_1_vu_meter_r + 1)*2+1] = math.min(remote.get_item_value(item_index) * 127 / (32 - 1), 127)
      vu_meters_changed = true
    elseif highlight_selected_track and item_index == items.target_track_name then
      local channel_name = trim(remote.get_item_text_value(item_index))
      local previous_channel_index = channel_name_to_index[current_channel_name] or 0
      local global_channel_index = channel_name_to_index[channel_name]
      current_channel_name = channel_name

      if global_channel_index ~= nil then
        local previous_mixer_page = math.floor((previous_channel_index-1) / 8)
        local next_mixer_page = math.floor((global_channel_index-1) / 8)
        if previous_mixer_page == next_mixer_page or previous_channel_index == 0 then
          local channel_index = global_channel_index - remote_base_channel
          local channel_hex = numbers_to_hex{channel_index}
          local channel_selected = is_channel_selected(channel_name) and "01" or "00"
          if channel_selected == "01" then
            table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 42" .. channel_selected .. channel_hex .. "f7"))
          end
        elseif previous_mixer_page ~= next_mixer_page then
          table.insert(pending_inputs, {item=items.remote_base_channel, value=math.floor((global_channel_index - 1) / 8) * 8 + 1})
          table.insert(pending_events, remote.make_midi("bf 01 01"))
        end
      elseif previous_channel_index > 0 then
        -- Disable previous active channel
        local channel_index = previous_channel_index - remote_base_channel
        local channel_hex = numbers_to_hex{channel_index}
        table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 42 00" .. channel_hex .. "f7"))
      end
    end
  end
end

function remote_process_midi(event)
  if remote.get_time_ms() - start_time < 500 then return end

  for i, msg in ipairs(pending_inputs) do
    remote.handle_input{timestamp=event.timestamp, item=msg.item, value=msg.value}
  end
  pending_inputs={}

  local level_event = remote.match_midi("bf 5z <0yxx>x", event)
  if level_event ~= nil and level_event.z >= 0 and level_event.z < 8 then
    local channel_index = level_event.z+1
    -- local level_delta = 1 - level_event.y * 2
    local level_delta = level_event.x - 64 * level_event.y
    mixer_levels[channel_index] = math.max(0, math.min(1000, mixer_levels[channel_index] + level_delta))
    remote.handle_input{timestamp=event.timestamp, item=items.channel_1_level+level_event.z, value=mixer_levels[channel_index]}
    return true
  end

  local pan_event = remote.match_midi("bf 5z <0yxx>x", event)
  if pan_event ~= nil and pan_event.z >= 8 and pan_event.z < 0x10 then
    local channel_index = pan_event.z - 8 + 1
    local pan_delta = pan_event.x - 64 * pan_event.y
    mixer_pans[channel_index] = math.max(-100, math.min(100, mixer_pans[channel_index] + pan_delta))
    remote.handle_input{timestamp=event.timestamp, item=items.channel_1_pan+channel_index-1, value=mixer_pans[channel_index]}
    return true
  end

  local mute_event = remote.match_midi("bf 43 xx", event)
  if mute_event ~= nil then
    remote.handle_input{timestamp=event.timestamp, item=items.channel_1_mute+mute_event.x, value=mixer_mutes[mute_event.x+1]==1 and 0 or 1}
    return true
  end

  local solo_event = remote.match_midi("bf 44 xx", event)
  if solo_event ~= nil then
    remote.handle_input{timestamp=event.timestamp, item=items.channel_1_solo+solo_event.x, value=mixer_solos[solo_event.x+1]==1 and 0 or 1}
    return true
  end

  local jog_volume_event = remote.match_midi("bf 64 xx", event)
  if jog_volume_event ~= nil then
    remote.handle_input{timestamp=event.timestamp, item=items.jog_wheel, value=64-jog_volume_event.x}
    return true
  end

  local jog_pan_event = remote.match_midi("bf 65 xx", event)
  if jog_pan_event ~= nil then
    remote.handle_input{timestamp=event.timestamp, item=items.jog_wheel, value=64-jog_pan_event.x}
    return true
  end



  return false
end

function remote_deliver_midi(max_bytes, port)
  if remote.get_time_ms() - start_time < 500 then return {} end

  if mixer_page_buttons_changed then
    update_mixer_page_buttons()
  end

  if vu_meters_changed then
    table.insert(pending_events, remote.make_midi("f0 00 21 09 00 00 44 43 01 00 49 02" .. numbers_to_hex(mixer_vu_meters) .. "f7"))
    vu_meters_changed = false
  end

  local ret_events = pending_events
  pending_events = {}
	return ret_events
end


-- Helper functions
function string_to_hex(text)
	local hexStringToReturn = ""
	for i = 1, string.len(text) do
		if string.len(hexStringToReturn) > 0 then 
			hexStringToReturn = hexStringToReturn .. " "
		end
		hexStringToReturn = hexStringToReturn .. string.format("%02X", string.byte(text, i))   
	end

	return hexStringToReturn
end

function numbers_to_hex(numbers)
	local hexStringToReturn = ""
	for i,number in ipairs(numbers) do
		if string.len(hexStringToReturn) > 0 then 
			hexStringToReturn = hexStringToReturn .. " "
		end
		hexStringToReturn = hexStringToReturn .. string.format("%02X", number)   
	end

	return hexStringToReturn
end

function trim(s)
  return s:match"^%s*(.*)":match"(.-)%s*$"
end

function is_channel_selected(channel_name)
  return channel_name ~= "" and channel_name == current_channel_name
end

function update_mixer_page_buttons()
  local arrow_buttons = 0
  if remote_base_channel > 1 and max_remote_base_channel == remote_base_channel then
    arrow_buttons = 1
  elseif remote_base_channel == 1 and max_remote_base_channel > remote_base_channel then
    arrow_buttons = 2
  elseif remote_base_channel > 1 and max_remote_base_channel > remote_base_channel then
    arrow_buttons = 3
  end
  table.insert(pending_events, remote.make_midi(numbers_to_hex{0xbf, 0x31, arrow_buttons}))
  mixer_page_buttons_changed=false
end